/*
 * OrderHandler.java
 *
 * Created on 10 de agosto de 2004, 18:08
 */

package com.fenalco.servlets.supplier;

import java.io.IOException;
import java.util.Hashtable;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.fenalco.entities.Log;
import com.fenalco.entities.Order;
import com.fenalco.entities.OrderProduct;
import com.fenalco.entities.User;
import com.fenalco.utilities.MessageBuilder;
import com.fenalco.utilities.database.Transaction;

/**
 * Este servlet procesa las operaciones solicitadas al realizar la selección de
 * una orden de compra o una búsqueda sobre el listado.
 * 
 * @author andres
 */
public class OrderHandler extends HttpServlet
{

	/**
	 * Inicializa el servlet.
	 * 
	 * @param config
	 *            Parámetro de configuración
	 * @throws ServletException
	 *             Excepción de fallo en la operación de inicialización
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destruye el servlet.
	 */
	public void destroy( )
	{

	}

	/**
	 * Procesa las peticiones para los métodos HTTP <code>GET</code> y
	 * <code>POST</code>.
	 * 
	 * Este método identifica el tipo de petición y actúa según sea el caso,
	 * esencialmente cambia el criterio de búsqueda del listado de ordenes de
	 * compra y permite responder o rechazar una orden de compra emitida por un
	 * minorista.
	 * 
	 * Utiliza el método orderResponse de la clase Order para responder un
	 * pedido y enviar un correo de notificación
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones
	 * @throws IOException
	 *             Excepción de fallo en la operación de escritura con el flujo
	 *             <CODE>PrintWriter</CODE> de response
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		HttpSession session = request.getSession(false);
		RequestDispatcher dispatcher;
		String url;
		String message = "";

	    try
	    {
	        if( session == null || ( User )session.getAttribute( "user" ) == null || ( ( User )session.getAttribute( "user" ) ).getRoleId() != 2 )
			{
				url = "/logout";
				//message = "Sesión no iniciada";
				message = MessageBuilder.buildMessage(15);
			}
			else
			{
				url = "/proveedor/ordenesdecompra";
				int orderStatus = Integer
						.parseInt(request.getParameter("newState"));
	
				/*
				 * if(orderStatus==2){ //Cancelar Pedido --> se elimina el pedido???
				 * }else{ /*Se debe modificar el pedido con los productos
				 * seleccionados, actualizar el estado a enviado y enviar el correo
				 * de respuesta }
				 */
	
				Transaction t = new Transaction();
				Order order = new Order(
						new Integer(request.getParameter("orderId")).intValue());
				Hashtable products = new Hashtable();
	
				if( request.getParameterValues("item") != null )
				{
					String[] items = request.getParameterValues("item");
					for( int i = 0; i < items.length; i++ )
					{
						Integer key = new Integer(items[i]);
						OrderProduct op = new OrderProduct(key.intValue());
						products.put(key, op);
					}
				}
	
				int newState = new Integer(request.getParameter("newState"))
						.intValue();
	
				if( newState == 2 )
				{
					order.delete(t);
				}
				else
				{
					order.setProducts(products);
					order.update(t);
				}
	
				boolean mailSent = order.orderResponse(t, newState, request
						.getParameter("subject"), request
						.getParameter("answerMessage"));
	
				//if(sendMail && !t.execute()){
				if( !t.execute() )
				{
					//Fallo al actualizar el pedido
					message = MessageBuilder.buildMessage(7);
				}
				else
				{
					//Todo OK
					//Actualizacion exitosa
					message = MessageBuilder.buildMessage(4);
					
					
					// guardo el registro en el log
	                try
	                {
	                    Transaction t1 = new Transaction( );
	                    Log l = new Log( );
	                    User user = ( User )session.getAttribute( "user" );
	                    String userId = user.getLogin();
	                    String numberId = user.getIdentificationNumber();
	                    String externalUser = "";
	                    String description = "Se cambio el estado del pedido " + order.getId()
											+ " a " + orderStatus;
	                    User callcenter = ( User )session.getAttribute( "callcenter" );
	                    if( callcenter != null )
	                    {
	                        externalUser = callcenter.getLogin();
	                    }
	                    l.saveData(userId, numberId, 54, description, externalUser, t1 );
	                    t1.execute();
	                }
	                catch( Exception ex )
	                {
	                    System.out.println( "Error guardando el Log." );
	                }
	
				}
			}
	    }
	    catch( Exception e )
	    {
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }

		request.setAttribute("message", message);
		dispatcher = getServletContext().getRequestDispatcher(url);
		dispatcher.forward(request, response);
	}

	/**
	 * Maneja el método HTTP <code>GET</code>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones
	 * @throws IOException
	 *             Excepción de fallo en la operación de escritura con el flujo
	 *             <CODE>PrintWriter</CODE> de response
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Maneja el método HTTP <code>POST</code>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones
	 * @throws IOException
	 *             Excepción de fallo en la operación de escritura con el flujo
	 *             <CODE>PrintWriter</CODE> de response
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Información general del servlet.
	 * 
	 * @return Retorna descripción general del servlet.
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

}